function handleKey(event) {
    switch (event.keyCode) {
    case 110: // 'n'
    case 112: // 'p'
    case 117: // 'u'
        simpleMove(event.keyCode);
        break;
    }
}
function findTag(name) {
    //FIXME we want to do the following, but we need to fix makeinfo output.
    //return document.getElementById(curHash);
    for (var cur = document.firstChild; ;) {
        if (cur == null || cur == document)
            break;
        if (cur instanceof Element) {
            if (cur.nodeName == "A" && cur.getAttribute("name") == name)
                return cur;
            if (cur.getAttribute("id") == name)
                return cur;
        }
        if (cur instanceof Element && cur.firstChild) {
            cur = cur.firstChild;
        } else if (cur.nextSibling)
            cur = cur.nextSibling;
        else {
            for (;;) {
                cur = cur.parentNode;
                if (cur == document)
                    break;
                if (cur.nextSibling) {
                    cur = cur.nextSibling;
                    break;
                }
            }
        }
    }
    return null;
}

function simpleMove(keyCode) {
    var curHash = location.hash.substring(1);
    var cur = findTag(curHash);
    if (cur && cur.nodeName == "A") {
        cur = cur.nextSibling;
        if (cur instanceof Text)
            cur = cur.nextSibling;
        if (cur.nodeName == "DIV")
            cur = cur.firstChild;
        if (cur instanceof Text)
            cur = cur.nextSibling;
        if (cur.nodeName == "P") {
            for (var ch = cur.firstChild; ch != null; ch = ch.nextSibling) {
                if (ch.nodeName == "A") {
                    var acc = ch.getAttribute("accesskey");
                    if (acc && acc.charCodeAt(0) == keyCode) {
                        var href = ch.getAttribute("href");
                        if (href)
                            location.href = href;
                    }
                }
            }
        }
    }
}
document.onkeypress = handleKey;
